pub struct Stats {
    pub score: u32,
    pub gems: u32,
    pub whips: u32,
    pub whip_power: u32,
    pub teleports: u32,
    pub keys: u32,
}

type PlayerSurvived = bool;

impl Stats {
    pub fn take_gems(&mut self, num_gems: u32) -> PlayerSurvived {
        let new_num_gems = self.gems as i64 - num_gems as i64;
        if new_num_gems <= 0 {
            self.gems = 0;
            false
        } else {
            self.gems = new_num_gems as u32;
            true
        }
    }

    pub fn add_score(&mut self, score: u32) {
        self.score += score;
    }
}
